Codeforces Round #384 (Div. 2) E. Vladik and cards 状压dp

E. Vladik and cards

题目链接

http://codeforces.com/contest/743/problem/E

题面

Vladik was bored on his way home and decided to play the following game. He took n cards and put them in a row in front of himself. Every card has a positive integer number not exceeding 8 written on it. He decided to find the longest subsequence of cards which satisfies the following conditions:

the number of occurrences of each number from 1 to 8 in the subsequence doesn’t differ by more then 1 from the number of occurrences of any other number. Formally, if there are ck cards with number k on them in the subsequence, than for all pairs of integers the condition |ci - cj| ≤ 1 must hold.
if there is at least one card with number x on it in the subsequence, then all cards with number x in this subsequence must form a continuous segment in it (but not necessarily a continuous segment in the original sequence). For example, the subsequence [1, 1, 2, 2] satisfies this condition while the subsequence [1, 2, 2, 1] doesn’t. Note that [1, 1, 2, 2] doesn’t satisfy the first condition.
Please help Vladik to find the length of the longest subsequence that satisfies both conditions.

输入

The first line contains single integer n (1 ≤ n ≤ 1000) — the number of cards in Vladik’s sequence.

The second line contains the sequence of n positive integers not exceeding 8 — the description of Vladik’s sequence.

输出

Print single integer — the length of the longest subsequence of Vladik’s sequence that satisfies both conditions.

样例输入

3
1 1 1

样例输出

1

题意

给你n个数字,你需要找到一个最长的子序列,满足以下要求:

1.对于每个i和j,要求abs(num[i]-num[j])<=1,num[i]表示这个数字i出现的次数

2.所有相同的数字应该挨在一起。

求最长的子序列长度

题解

枚举每个数字的长度num,那么显然每个数字要么是num,要么就是num+1

然后我们对于每个长度进行check就好了

dp[i][j]表示当前状态为i的时候,其中有i个数的长度为num+1,用一个next进行转移就好了

next[i][j][k]表示从i开始,j出现k次的位置是啥位置。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1050;
int dp[maxn][9];
int nxt[maxn][9][maxn],a[maxn],n,cnt[9];
int main()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
    for(int i=1;i<=n;i++){
        for(int j=1;j<=8;j++)cnt[j]=0;
        for(int j=1;j<=8;j++)for(int k=1;k<=n;k++)
            nxt[i][j][k]=1e9;
        for(int j=i;j<=n;j++){
            cnt[a[j]]++;
            nxt[i][a[j]][cnt[a[j]]]=j;
        }
    }
    int ans=0;
    for(int num=0;num*8<=n;num++){
        for(int i=0;i<256;i++)
            for(int k=0;k<=8;k++)
                dp[i][k]=1e9;
        dp[0][0]=1;
        for(int i=0;i<256;i++){
            for(int j=0;j<=8;j++){
                for(int k=1;k<=8;k++){
                    if((1<<(k-1))&i)continue;
                    if(dp[i][j]>n)continue;
                    dp[i^(1<<(k-1))][j]=min(dp[i^(1<<(k-1))][j],nxt[dp[i][j]][k][num]+1);
                    dp[i^(1<<(k-1))][j+1]=min(dp[i^(1<<(k-1))][j+1],nxt[dp[i][j]][k][num+1]+1);
                }
            }
        }
        for(int i=0;i<=8;i++)if(dp[255][i]<=n+1)ans=max(ans,8*num+i);
    }
    cout<<ans<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/6193189.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞